/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code shows how to retrieve mouse clicks from a drawing
area.
***************************************************************/

/* clicks.c */

#include <Xm/Xm.h>
#include <Xm/DrawingA.h>

#define size    400

XtAppContext context;

Widget toplevel, drawing_area;

void handle_click(w,client_data,event)
    Widget w;
    XtPointer client_data;
    XEvent *event;
{
    printf("%d %d\n",event->xbutton.x,event->xbutton.y);
}

void main(argc,argv)
    int argc;
    char *argv[];
{
    Arg al[10];
    int ac;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,
        NULL,NULL,0);

    /* default window size. */
    ac=0;
    XtSetArg(al[ac],XmNheight,size); ac++;
    XtSetArg(al[ac],XmNwidth,size); ac++;
    XtSetValues(toplevel,al,ac);

    /* create drawing area */
    ac=0;
    drawing_area=XmCreateDrawingArea(toplevel,"drawing_area",al,ac);
    XtManageChild(drawing_area);    
    /* add in event handler */
    XtAddEventHandler(drawing_area,ButtonReleaseMask,
        FALSE,handle_click,NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
