/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code demonstrates the three pushbutton callbacks.
***************************************************************/

/* all_callbacks.c */

#include <Xm/Xm.h>
#include <Xm/PushB.h>

XtAppContext context;
XmStringCharSet char_set=XmSTRING_DEFAULT_CHARSET;

Widget toplevel, button;

void handle_button(w,client_data,call_data)
    Widget w;
    int client_data;
    XmPushButtonCallbackStruct *call_data;
/* handles callbacks generated by the pushbutton */
{
    switch (client_data)
    {
        case 1:
            printf("activate\n");
            break;
        case 2:
            printf("arm\n");
            break;
        case 3: 
            printf("disarm\n");
            break;
    }
}

void main(argc,argv) 
    int argc; 
    char *argv[];
{
    Arg al[10];
    int ac;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,NULL,NULL,0);

    /* create the button widget */
    ac=0;   
    XtSetArg(al[ac],XmNlabelString, 
        XmStringCreate("Push Me",char_set)); ac++;
    button=XmCreatePushButton(toplevel,"button",al,ac);
    XtManageChild(button);
    XtAddCallback(button,XmNactivateCallback,handle_button,1); 
    XtAddCallback(button,XmNarmCallback,handle_button,2);
    XtAddCallback(button,XmNdisarmCallback,handle_button,3);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
